
#include "ReadWrite.h"


/*!
 * \brief : check is a node is already in a graph.
 * if not, insert it
 * Return id of the node
 * Return false if the node has been inserted
 */

int checkAndInsertNode( Graph & g,  map<string, int> & nodeIdMap, const string nameNode)
{
    auto it = nodeIdMap.find(nameNode);
    //assert( it != nodeIdMap.end());
    if( it != nodeIdMap.end())
    {
        return (it->second);
    }
    else // Was not not the graph
    {
       // vertex_t u  =
                add_vertex(VertexProperties( nameNode, 0), g);
        int idNN= (num_vertices(g)- 1);
        nodeIdMap.insert(pair<string,int>(nameNode, idNN));

        cout << "node only in hyperarcs " << nameNode << endl;

        return (idNN) ;
    }

}


//====================
Graph readAsCompoundGraph( string nameFileEdge, string nameFileHyperEdge)
{

    // TODO: take graph and copy node & edges!
   // nOT REREAD EVERYTHIN!

    // First file all the graph with the node and simple are
    map<string, vertex_t> checkNodes;
    Graph gCompound = readGraphFile( nameFileEdge, checkNodes );
    auto nameM = boost::get(&VertexProperties::name, gCompound);
    map<string, int> nodeIdMap;
    for ( unsigned int i=0; i<num_vertices(gCompound); i++) {
          nodeIdMap.insert(pair<string,int>(nameM[i], i));
    }
    vector<HyperArc> myHypers = readHyperArcsFile(nameFileHyperEdge, nodeIdMap, gCompound);
    //========== Adding hyperedges as simple arcs
    // A arc has a weight of weight_original/badness
   VertexIndexMap index_map = get(vertex_index, gCompound);
   vertex_t subV, prodV;
   for( HyperArc currentA : myHypers)
   {
       double weight = currentA.weight/ currentA.substrates.size();
 //      cout << " current weight is " << weight << endl;
       for( int sub : currentA.substrates)
       {
           for( int pro : currentA.products)
           {
               subV  = index_map[sub];
               prodV = index_map[pro];
               add_edge(subV,prodV, EdgeProperties( weight , num_edges(gCompound) ), gCompound);
               //myVerticesMap
           }
       }
   }




    return gCompound;
}






//=============== Read Graph
Graph readGraphFile(string nameFile, map<string, vertex_t> & checkNodes)
{
    cout << "opening " << nameFile << endl;
    ifstream f(nameFile);
    if( f.peek() == ifstream::traits_type::eof())
    {
        cout << " File is empty"<< endl;
        throw std::exception();
    }

    Graph g;
    // writing out the edges in the graph
    cout << "readGRAPH" <<  endl;
    string line;
    vertex_t u,v;
    unsigned int idE = 0 ;// TODO  ca ne sert à rien/enlever
    int nbLine = 0;
    vector<string> strs;
    while(getline(f, line))
    {
        strs.clear();
        boost::split(strs, line, boost::is_any_of(" \t")); // TODO : without the whitespace
        if(nbLine == 0) // ReadTheSource
        {
            for(auto meta : strs)
            {
                assert(checkNodes.count(meta) == 0); // Checking if nodes not inserted double times;
                u = add_vertex(VertexProperties(meta, -1 ), g);
                checkNodes.insert(pair<string, vertex_t>(meta, u));
                //                cout << meta << " added as source"<< endl;
            }
        }
        else if (nbLine == 1 )// ReadTheTargets
        {
            for(auto meta : strs)
            {
                assert(checkNodes.count(meta) == 0); // Checking if nodes not inserted double times;
                u = add_vertex(VertexProperties(meta, 1), g);
                checkNodes.insert(pair<string, vertex_t>(meta, u));
                //              cout << meta << " added as target "<< endl;
            }
        }
        else{ // Reading the edges
            if(strs.size()!=3){cout << "problem reading the graph file"<<  endl; cout << line<< " " << strs.size() <<  endl;}
            else{
                if(checkNodes.count(strs[0])== 0)// nb : we should be able to do it in another way!
                {
                    u = add_vertex(VertexProperties( strs[0], 0), g);
                    checkNodes.insert(pair<string, vertex_t>(strs[0], u));
                }
                else
                {                   u = checkNodes.at(strs[0]);            }
                if(checkNodes.count(strs[1])== 0)// nb : we should be able to do it in another way!
                {
                    v = add_vertex(VertexProperties( strs[1],0), g);
                    checkNodes.insert(pair<string, vertex_t>(strs[1], v));
                }
                else
                {                   v = checkNodes.at(strs[1]);            }
                add_edge(u,v, EdgeProperties(atof( strs[2].c_str() ) , idE), g);
                ++idE;
                //            cout << strs[0] << "  ---->   " << strs[1]<<  endl;
            }
        }
        ++nbLine;
    }
    f.close();
    cout << "=======================" << endl;

    return g;
}


//=============== Read Graph

vector<HyperArc> readHyperArcsFile(string nameFile, map<string, int> & nodeIdMap, Graph & g)
                {
    vector<HyperArc> myHyper;
    unsigned int ii=0 ;
    cout << "opening " << nameFile << endl;
    ifstream f(nameFile);
    if( f.peek() == ifstream::traits_type::eof())
    {
        cout << " File is empty"<< endl;
        throw std::exception();
    }

    string line ;
    vector<string> strs, headNodes, tailNodes;
    vector<int> headNodeIds, tailNodeIds;
    int idNT, idNH;

    while(getline(f, line))
    {
        // Initialization
        strs.clear();
        headNodes.clear();
        tailNodes.clear();
        headNodeIds.clear();
        tailNodeIds.clear();
        // Spliting the line to get Substrates  Products    Weigth
        boost::split(strs, line, is_any_of("\t "));

        assert( strs.size()== 3);//"Hyperarcs should be one set of head, one set of tails and the weight"
        boost::split(tailNodes, strs[0], is_any_of(" ,"));
        boost::split(headNodes, strs[1], is_any_of(", "));
        // TODO : addd NDEBUG macro!
        for(string itN : tailNodes)
        {   
            idNT = checkAndInsertNode(g, nodeIdMap, itN);
            tailNodeIds.push_back(idNT);
        }
        for(string itN : headNodes)   
        {
            idNH = checkAndInsertNode(g, nodeIdMap, itN);
            headNodeIds.push_back( idNH );
        }

        myHyper.push_back( HyperArc(ii, atof(strs[2].c_str()), tailNodeIds, headNodeIds) );
        ++ii;
    }
    f.close();
    return myHyper;
                }




void writeGraphViz(const  char *  filename, Graph g )
{
    ofstream of;
    of.open(filename);

    //   write_graphviz()
    write_graphviz (of, g,     boost::make_label_writer( boost::get(&VertexProperties::name, g)),     boost::make_label_writer(boost::get(&EdgeProperties::weight, g)));
    of.close();

}
